import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.writek;
import win32frame.WindowObject;
import win32frame.Frame;
import win32frame.WindowMenu;
import win32frame.StatusBar ;
import win32frame.ToolBarEx;
import win32frame.Rebar;

import std.stdio;
import std.string;
import std.utf;

ushort LOWORD(uint l){ return l & 0xffff; }
ushort HIWORD(uint l){ return l >>> 16; }


class MainWindow : Frame {
  Rebar  reBar ;
  int    rebarWidth  ;
  int    rebarHeight ;
  int    with_rebar=0 ;
  HWND[] bc_wmsize_List ; // WM_SIZEをブロードキャストするHWNDリスト

  this(string name, string ClassName) {
    super(name) ;
  }

  int withRebar(){
    with_rebar=1 ;
    return(0) ;
  }

  bool setMenu(WindowMenu menu){
    return( cast(bool)( SetMenu(this.hwnd , menu.getHMENU()) ) ) ;
  }
  
  int setREBARBANDINFO(REBARBANDINFO rbbi){
    if( with_rebar!=0 ){
      if( reBar !is null ){
	return(reBar.setREBARBANDINFO(rbbi)) ;
      }
    }
    return(-1) ;
  }
  
  int addonRebar(WindowObject WObj){
    if( with_rebar==0 ) return(-1) ;
    return( reBar.addWindowObject(WObj) ) ;
  }

  int addonRebar(ToolBarEx toolbar){
    if( with_rebar==0 ) return(-1) ;
    return( reBar.addTool(toolbar) ) ;
  }

  int addStatusBar(StatusBar StBar, string msg){
    HWND stbhwnd ;
    int  ret ;
    ret = StBar.create(this.hwnd, msg) ;
    stbhwnd = StBar.getHWND() ;
    if( stbhwnd != null ){
      bc_wmsize_List.length = bc_wmsize_List.length+1 ;
      bc_wmsize_List[(bc_wmsize_List.length-1)]=stbhwnd ;
      _statusBar = StBar ;
    }
    return( ret ) ;
  }

  override LRESULT preproc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch( msg ){
    case WM_CREATE:
      if( with_rebar==1 ){
	reBar = new Rebar("Rebar") ;
	addObject(reBar, null, true, true) ;
      }
      break ;

    case WM_NOTIFY :
      LPNMHDR lpnmhdr ;
      lpnmhdr = cast(LPNMHDR)(lp) ;
      if( with_rebar==1 ){
	if( lpnmhdr.hwndFrom == reBar.getHWND() ){
	  if( lpnmhdr.code == RBN_HEIGHTCHANGE){
	    InvalidateRect(this.hwnd, null, true) ;
	    UpdateWindow(reBar.getHWND()) ;
	    RECT rc ;
	    GetClientRect( reBar.getHWND(), &rc ) ;
	    rebarHeight = rc.bottom - rc.top +2 ;
	    GetWindowRect( this.hwnd, &rc ) ;
	    SendMessage(this.hwnd, WM_SIZE, 0, ((rc.right - rc.left)<<16 | (rc.bottom - rc.top)) ) ;
	  }
	}
      }
      break ;
      
    case WM_MOVE :
      winX=LOWORD(lp) ;
      winY=HIWORD(lp) ;
      break ;

    case WM_SIZE :
      winW=LOWORD(lp) ;
      winH=HIWORD(lp) ;
      
      RECT rc ;
      GetClientRect( hwnd, &rc ) ;
      if( _statusBar !is null ){
	RECT rc_statbar ;
	GetWindowRect( _statusBar.getHWND(), &rc_statbar ) ;
	rc.bottom -= (rc_statbar.bottom - rc_statbar.top) ;
      }
      for( int i=fitWOBJ_List.length-1 ; i>=0 ; i-- ){
	if( fitWOBJ_List[i] !is null ){
	  
	  if( with_rebar==1 ){
	    if( reBar.getHWND() == cast(HWND)(fitWOBJ_List[i].getHWND()) ){
	      MoveWindow( cast(HWND)(fitWOBJ_List[i].getHWND()), 0, 0, (rc.right - rc.left), (rc.bottom - rc.top), true ) ;
	    }else{
	      MoveWindow( cast(HWND)(fitWOBJ_List[i].getHWND()), 0, rebarHeight+2, (rc.right - rc.left), (rc.bottom - rc.top) - rebarHeight, true ) ;
	    }
	  }else{
	    MoveWindow( cast(HWND)(fitWOBJ_List[i].getHWND()), 0, 0, (rc.right - rc.left), (rc.bottom - rc.top), true ) ;
	  }
	}
      }
      for( int i=bc_wmsize_List.length-1 ; i>=0 ; i-- ){
	SendMessage( cast(HWND)(bc_wmsize_List[i]), WM_SIZE, wp, lp);
      }
      break ;
      
    default : break ;
    }
    
    return( this.proc(hwnd , msg , wp , lp) ) ;
  }
}
